/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.gebietsbaum.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsarteigenschaft;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractGebietsarteigenschaftSearch {

  @Inject
  protected transient GebietsarteigenschaftExtendedDAO dao;

  public AbstractGebietsarteigenschaftSearch() {
    super();
  }

  public List<Gebietsarteigenschaft> getSearchResult(GebietsarteigenschaftSearchParameters searchParameters, EagerLoadingCollector<Gebietsarteigenschaft> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Gebietsarteigenschaft> querySearchResult(GebietsarteigenschaftSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
